#pragma once
#include "gtkmm/box.h"
#include "audio/misc/circular_audio_buffer.h"

#include "widget/misc/w_volume_bar.h"

class delta_timer;
class w_audio_buffer_bar : public Gtk::Box {
public:
    using weak_buffer = std::weak_ptr<std::vector<circular_audio_buffer<float>>>;
    using ref_buffer = std::vector<circular_audio_buffer<float>>&;

    w_audio_buffer_bar();
    void set_buffers(weak_buffer in_buffers);

    weak_buffer buffers;
private:
    static w_volume_bar* create_volume_bar();
    void on_timer(double delta_time);
    std::vector<w_volume_bar*> volume_bars_;
    std::shared_ptr<delta_timer> timer_;
};
